package com.chinaitop.depot.unissoft.webservice;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.annotation.Resource;

import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.basic.mapper.BasicWarehouseMapper;

@Service
public class BasicWarehouseWebServiceImpl implements BasicWarehouseWebService {

	@Resource
	private BasicWarehouseMapper warehouseMapper;

	@Override
	@SuppressWarnings("all")
	public String uploadCfStatus(String json) {
		Map<String, Object> result = new HashMap<String, Object>();

		try {
			if (null != json) {
				/* 将获取到的json串转换成json数组 */
				JSONArray json_array = JSONArray.parseArray(json);
				JSONObject json_object = null;

				/* 遍历json数组，获取数组中值 */
				for (Iterator iterator = json_array.iterator(); iterator.hasNext();) {

					/* 获取json对象 */
					json_object = (JSONObject) iterator.next();
					if (json_object == null) {
						continue;
					}

					//货位ID
					String wareId = ObjectUtils.toString(json_object.get("hwId"), "");
					//单位ID
					String orgId = ObjectUtils.toString(json_object.get("org_Id"), "");
					//货位状态值1空仓,2入库中,3封仓,4出库中,9其它
					String status = ObjectUtils.toString(json_object.get("status"), "");

					//修改数据
					Map<String, Object> param = new HashMap<String, Object>();
					param.put("wareId", Integer.parseInt(wareId));
					param.put("orgId", Integer.parseInt(orgId));
					param.put("status", status);
					warehouseMapper.updateWareStatus(param);
				}
			}
			result.put("success", "true");
			result.put("msg", "上传成功");
		} catch (NumberFormatException e) {
			e.printStackTrace();
			result.put("success", "false");
			result.put("msg", "上传失败");
		} finally {
			JSONArray jsonArray = new JSONArray();
			jsonArray.add(result);
			return jsonArray.toString();
		}
	}

}
